## qdmr 0.12.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
project(qdmr VERSION 0.12.1)

set(RELEASE_SUFFIX "")

option(BUILD_TESTS "Build test programs" OFF)
option(BUILD_DOCS  "Build API documentation" OFF)
option(BUILD_MAN   "Build man page for dmrconf" OFF)
option(INSTALL_UDEV_RULES "Install udev rules file." ON)
option(INSTALL_UDEV_PATH "Install path of udev rules file." "/etc/udev/rules.d")
option(INSTALL_BUNDLE "Installs QDMR as an AppBundle under MacOS X" OFF)
option(BUNDLE_PATH "Where to install the MacOS X application bundle." "~/Applications")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

find_package(Qt5Core REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5UiTools REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5SerialPort REQUIRED)
find_package(Qt5Positioning REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(LIBUSB_1 REQUIRED)
find_package(YAMLCPP REQUIRED)

if (${BUILD_MAN})
  find_program(XSLTPROC_EXECUTABLE xsltproc DOC "xsltproc for man-page generation." REQUIRED)
endif(${BUILD_MAN})

if (${BUILD_DOCS})
  find_package(Doxygen REQUIRED dot)
endif(${BUILD_DOCS})

if (${BUILD_TESTS})
  find_package(Qt5Test REQUIRED)
endif(${BUILD_TESTS})

ADD_DEFINITIONS(${Qt5Widgets_DEFINITIONS})
#add_definitions("-DQT_EVENT_DISPATCHER_CORE_FOUNDATION=1")

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

INCLUDE_DIRECTORIES(${Qt5Core_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Widgets_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5UiTools_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Network_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5SerialPort_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Positioning_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${Qt5Test_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${LIBUSB_1_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${YAMLCPP_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/lib)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/lib)

LINK_DIRECTORIES(${PROJECT_BINARY_DIR}/src)

set(CORE_LIBS ${Qt5Core_LIBRARIES} ${Qt5Core_QTMAIN_LIBRARIES} ${Qt5Network_LIBRARIES}
  ${Qt5Positioning_LIBRARIES} ${Qt5SerialPort_LIBRARIES} ${LIBUSB_1_LIBRARIES}
  ${YAMLCPP_LIBRARIES})
if (${BUILD_TESTS})
  set(CORE_LIBS ${CORE_LIBS} ${Qt5Test_LIBRARIES})
endif(${BUILD_TESTS})

set(LIBS ${CORE_LIBS} ${Qt5Widgets_LIBRARIES} ${Qt5UiTools_LIBRARIES})

IF (UNIX AND APPLE)
 SET(CORE_LIBS ${CORE_LIBS} "-framework IOKit -framework CoreFoundation")
ENDIF(UNIX AND APPLE)

set(PROJECT_VERSION_STRING "\"${PROJECT_VERSION}\"")
message(STATUS "Build version ${PROJECT_VERSION}")

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} -Wall -Wsign-compare")
set(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS_DEBUG}  -O0 -ggdb -fstack-protector -Wextra")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -Wextra")


# Get default install directories under Linux
IF(UNIX AND NOT APPLE)
 INCLUDE(GNUInstallDirs)
ENDIF(UNIX AND NOT APPLE)
IF(UNIX AND APPLE)
 SET(CMAKE_INSTALL_LIBDIR "lib")
 SET(CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 SET(CMAKE_INSTALL_INCLUDEDIR "include")
 SET(CMAKE_INSTALL_FULL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
 # Set RPATH under MacOS
 SET(CMAKE_SKIP_RPATH FALSE)
 SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
 SET(CMAKE_SKIP_INSTALL_RPATH FALSE)
 SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 message(STATUS "RPATH: ${CMAKE_INSTALL_RPATH}")
ENDIF(UNIX AND APPLE)

# Directory to install translations to
SET(LOCALE_DIRECTORY "${CMAKE_INSTALL_PREFIX}/share/locale/")

# Sources...
add_subdirectory(lib)
add_subdirectory(cli)
add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(dist)

if(BUILD_TESTS)
 enable_testing()
 add_subdirectory(test)
endif(BUILD_TESTS)

# Source distribution packages:
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${PROJECT_VERSION}${RELEASE_SUFFIX}")
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/doc/html;/doc/latex;/doc/reveng;/doc/dmr-intro;/examples/*.dfu;/.git/;~$;.qm;*.user$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

=== cli/CMakeLists.txt ===
set(dmrconf_SOURCES main.cc
	printprogress.cc detect.cc verify.cc readcodeplug.cc writecodeplug.cc encodecodeplug.cc
  decodecodeplug.cc infofile.cc writecallsigndb.cc encodecallsigndb.cc progressbar.cc autodetect.cc)
set(dmrconf_MOC_HEADERS )
set(dmrconf_HEADERS
	printprogress.hh detect.hh verify.hh readcodeplug.hh writecodeplug.hh encodecodeplug.hh
  decodecodeplug.hh infofile.hh writecallsigndb.hh encodecallsigndb.hh progressbar.hh autodetect.hh
	${dmrconf_MOC_HEADERS})


qt5_wrap_cpp(dmrconf_MOC_SOURCES ${dmrconf_MOC_HEADERS})

add_executable(dmrconf WIN32 ${dmrconf_SOURCES} ${dmrconf_MOC_SOURCES})
target_link_libraries(dmrconf ${CORE_LIBS} libdmrconf)

install(TARGETS dmrconf DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== doc/CMakeLists.txt ===
#
# man-page generation
#
message(STATUS "Using xsltproc: ${XSLTPROC_EXECUTABLE}")
configure_file("dmrconf.in.xml" "dmrconf.xml")
configure_file("qdmr.in.xml" "qdmr.xml")

if(UNIX AND NOT APPLE)
  set(DOCBOOK2MAN_XSLT ${CMAKE_CURRENT_SOURCE_DIR}/docbook_man.debian.xsl)
elseif(UNIX AND APPLE)
  set(DOCBOOK2MAN_XSLT ${CMAKE_CURRENT_SOURCE_DIR}/docbook_man.macports.xsl)
endif(UNIX AND NOT APPLE)

add_custom_command(
  OUTPUT dmrconf.1
  COMMAND ${XSLTPROC_EXECUTABLE}
          -o ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
          ${DOCBOOK2MAN_XSLT}
          ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.xml
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating man-page for dmrconf."
  VERBATIM)

add_custom_command(
  OUTPUT qdmr.1
  COMMAND ${XSLTPROC_EXECUTABLE}
          -o ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1
          ${DOCBOOK2MAN_XSLT}
          ${CMAKE_CURRENT_BINARY_DIR}/qdmr.xml
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qdmr.xml
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating man-page for qdmr."
  VERBATIM)

if (${BUILD_MAN})
  # Create man page from docbook
  add_custom_target(dmrconf_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1)
  add_custom_target(qdmr_manpage ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1)
  # install man page on unix systems
  if (UNIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dmrconf.1
                  ${CMAKE_CURRENT_BINARY_DIR}/qdmr.1
      DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1/)
  endif (UNIX)
endif(${BUILD_MAN})

#
# optional API docs
#
if (${BUILD_DOCS})
  set(DOXYGEN_PROJECT_NAME "libdrmconf")
  set(DOXYGEN_PROJECT_BRIEF "A library to program DMR radios.")
  set(DOXYGEN_BRIEF_MEMBER_DESC YES)
  set(DOXYGEN_JAVADOC_AUTOBRIEF YES)
  set(DOXYGEN_EXAMPLE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/code")
  set(DOXYGEN_DOTFILE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  set(DOXYGEN_ENABLE_PREPROCESSING YES)
  set(DOXYGEN_MACRO_EXPANSION YES)
  set(DOXYGEN_EXPAND_ONLY_PREDEF YES)
  set(DOXYGEN_PREDEFINED __attribute__(x) =)
  set(DOXYGEN_IMAGE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/fig")
  doxygen_add_docs(apidocs
    ALL
    ${CMAKE_SOURCE_DIR}/lib
    COMMENT "Build API documentation")
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
          DESTINATION ${CMAKE_INSTALL_DOCDIR}/libdmrconf/)
endif(${BUILD_DOCS})

=== i18n/Makefile ===
update:
	lupdate ../src/*.cc ../src/*.hh ../src/*.ui ../shared/ui/*.ui -noobsolete -ts *.ts

=== lib/CMakeLists.txt ===
IF (APPLE)
 SET(hid_SOURCES hid_macos.cc)
 SET(hid_HEADERS hid_macos.hh)
 #SET(hid_SOURCES hid_libusb.cc)
 #SET(hid_HEADERS hid_libusb.hh)
ELSE (APPLE)
 SET(hid_SOURCES hid_libusb.cc)
 SET(hid_HEADERS hid_libusb.hh)
ENDIF(APPLE)

SET(libdmrconf_SOURCES
    utils.cc crc32.cc addressmap.cc radiointerface.cc errorstack.cc frequency.cc interval.cc
    ranges.cc dummyfilereader.cc chirpformat.cc
    signaling.cc
    radio.cc ${hid_SOURCES} dfu_libusb.cc usbserial.cc radioinfo.cc usbdevice.cc radiolimits.cc
    csvreader.cc dfufile.cc userdatabase.cc logger.cc
    melody.cc
    visitor.cc configlabelingvisitor.cc configcopyvisitor.cc intermediaterepresentation.cc
    configmergevisitor.cc
    configobject.cc configreference.cc config.cc radiosettings.cc contact.cc rxgrouplist.cc
    channel.cc zone.cc scanlist.cc gpssystem.cc codeplug.cc roamingzone.cc roamingchannel.cc
    callsigndb.cc talkgroupdatabase.cc radioid.cc encryptionextension.cc commercial_extension.cc
    smsextension.cc satellitedatabase.cc orbitalelementsdatabase.cc transponderdatabase.cc
    tyt_radio.cc tyt_interface.cc tyt_codeplug.cc tyt_callsigndb.cc tyt_extensions.cc
    md2017.cc md2017_codeplug.cc md2017_callsigndb.cc md2017_filereader.cc md2017_limits.cc
    md390.cc md390_codeplug.cc md390_filereader.cc md390_limits.cc
    uv390.cc uv390_codeplug.cc uv390_callsigndb.cc uv390_filereader.cc uv390_limits.cc
    dm1701.cc dm1701_codeplug.cc dm1701_callsigndb.cc dm1701_filereader.cc dm1701_limits.cc
    radioddity_radio.cc radioddity_codeplug.cc radioddity_extensions.cc radioddity_interface.cc
    rd5r.cc rd5r_codeplug.cc rd5r_filereader.cc rd5r_limits.cc
    gd77.cc gd77_codeplug.cc gd77_callsigndb.cc gd77_filereader.cc gd77_limits.cc
    opengd77_interface.cc opengd77base.cc opengd77base_codeplug.cc opengd77base_callsigndb.cc
    opengd77_extension.cc opengd77_limits.cc
    opengd77.cc opengd77_codeplug.cc opengd77_callsigndb.cc
    openuv380.cc openuv380_codeplug.cc openuv380_callsigndb.cc
    openrtx.cc openrtx_interface.cc openrtx_codeplug.cc
    c7000device.cc gd73.cc gd73_interface.cc gd73_codeplug.cc gd73_filereader.cc gd73_limits.cc
    anytone_interface.cc anytone_radio.cc anytone_codeplug.cc anytone_extension.cc anytone_limits.cc
    d868uv.cc d868uv_codeplug.cc d868uv_callsigndb.cc d868uv_limits.cc
    d878uv.cc d878uv_codeplug.cc d878uv_limits.cc
    d578uv.cc d578uv_codeplug.cc d578uv_limits.cc
    d878uv2.cc d878uv2_codeplug.cc d878uv2_limits.cc d878uv2_callsigndb.cc
    dmr6x2uv.cc dmr6x2uv_codeplug.cc dmr6x2uv_limits.cc
    auctus_a6_interface.cc
    dr1801uv.cc dr1801uv_interface.cc dr1801uv_codeplug.cc dr1801uv_filereader.cc dr1801uv_limits.cc)

SET(libdmrconf_MOC_HEADERS
    radio.hh ${hid_HEADERS} dfu_libusb.hh usbserial.hh radiolimits.hh
    csvreader.hh dfufile.hh userdatabase.hh logger.hh
    melody.hh
    configobject.hh configreference.hh config.hh radiosettings.hh contact.hh rxgrouplist.hh
    channel.hh zone.hh scanlist.hh gpssystem.hh codeplug.hh roamingzone.hh roamingchannel.hh
    callsigndb.hh talkgroupdatabase.hh radioid.hh encryptionextension.hh commercial_extension.hh
    smsextension.hh satellitedatabase.hh orbitalelementsdatabase.hh transponderdatabase.hh
    tyt_radio.hh tyt_interface.hh tyt_codeplug.hh tyt_callsigndb.hh tyt_extensions.hh
    md2017.hh md2017_codeplug.hh md2017_callsigndb.hh md2017_limits.hh
    md390.hh md390_codeplug.hh md390_limits.hh
    uv390.hh uv390_codeplug.hh uv390_callsigndb.hh uv390_limits.hh
    dm1701.hh dm1701_codeplug.hh dm1701_callsigndb.hh dm1701_filereader.hh dm1701_limits.hh
    radioddity_radio.hh radioddity_codeplug.hh radioddity_extensions.hh radioddity_interface.hh
    rd5r.hh rd5r_codeplug.hh rd5r_limits.hh
    gd77.hh gd77_codeplug.hh gd77_callsigndb.hh gd77_limits.hh
    opengd77_interface.hh opengd77base.hh opengd77base_codeplug.hh opengd77base_callsigndb.hh
    opengd77_extension.hh opengd77_limits.hh
    opengd77.hh opengd77_codeplug.hh opengd77_callsigndb.hh
    openuv380.hh openuv380_codeplug.hh openuv380_callsigndb.hh
    c7000device.hh gd73.hh gd73_interface.hh gd73_codeplug.hh gd73_limits.hh
    openrtx.hh openrtx_interface.hh openrtx_codeplug.hh
    anytone_interface.hh anytone_radio.hh anytone_codeplug.hh anytone_extension.hh anytone_limits.hh
    d868uv.hh d868uv_codeplug.hh d868uv_callsigndb.hh d868uv_limits.hh
    d878uv.hh d878uv_codeplug.hh d878uv_limits.hh
    d578uv.hh d578uv_codeplug.hh d578uv_limits.hh
    d878uv2.hh d878uv2_codeplug.hh d878uv2_limits.hh d878uv2_callsigndb.hh
    dmr6x2uv.hh dmr6x2uv_codeplug.hh dmr6x2uv_limits.hh
    auctus_a6_interface.hh
    dr1801uv.hh dr1801uv_interface.hh dr1801uv_codeplug.hh dr1801uv_limits.hh)

SET(libdmrconf_HEADERS libdmrconf.hh radiointerface.hh radioinfo.hh usbdevice.hh signaling.hh
    gd77_filereader.hh rd5r_filereader.hh uv390_filereader.hh md2017_filereader.hh gd73_filereader.hh
    md390_filereader.hh dr1801uv_filereader.hh dummyfilereader.hh
    utils.hh crc32.hh signaling.hh addressmap.hh errorstack.hh frequency.hh interval.hh ranges.hh
    chirpformat.hh
    visitor.hh configlabelingvisitor.hh configcopyvisitor.hh intermediaterepresentation.hh
    configmergevisitor.hh)



configure_file(config.h.in ${PROJECT_BINARY_DIR}/lib/config.h)

#SET(CMAKE_AUTOMOC ON)
qt5_wrap_cpp(libdmrconf_MOC_SOURCES ${libdmrconf_MOC_HEADERS})

add_library(libdmrconf SHARED ${libdmrconf_SOURCES} ${libdmrconf_MOC_SOURCES})
set_target_properties(libdmrconf PROPERTIES
	MACOSX_RPATH TRUE
  OUTPUT_NAME dmrconf
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}")
target_link_libraries(libdmrconf ${CORE_LIBS})

install(TARGETS libdmrconf DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR})
install(FILES ${libdmrconf_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${libdmrconf_MOC_HEADERS} DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)
install(FILES ${PROJECT_BINARY_DIR}/lib/config.h DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/libdmrconf)

if (UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})
  install(FILES "${CMAKE_SOURCE_DIR}/dist/99-qdmr.rules" DESTINATION ${INSTALL_UDEV_PATH})
endif(UNIX AND NOT APPLE AND ${INSTALL_UDEV_RULES})

=== src/CMakeLists.txt ===
SET(qdmr_SOURCES main.cc
  configitemwrapper.cc
  application.cc settings.cc dmrcontactdialog.cc dtmfcontactdialog.cc rxgrouplistdialog.cc
  analogchanneldialog.cc digitalchanneldialog.cc channelvalidator.cc channelcombobox.cc
  channelselectiondialog.cc zonedialog.cc scanlistdialog.cc
  verifydialog.cc gpssystemdialog.cc contactselectiondialog.cc searchpopup.cc
  aprssystemdialog.cc releasenotes.cc roamingzonedialog.cc roamingchannellistview.cc
  roamingchanneldialog.cc roamingchannelselectiondialog.cc
  configobjectlistview.cc configobjecttableview.cc
  generalsettingsview.cc radioidlistview.cc contactlistview.cc grouplistsview.cc channellistview.cc
  zonelistview.cc scanlistsview.cc positioningsystemlistview.cc roamingzonelistview.cc
  collapsablewidget.cc extensionview.cc extensionwrapper.cc propertydelegate.cc errormessageview.cc
  deviceselectiondialog.cc radioselectiondialog.cc dmriddialog.cc configobjecttypeselectiondialog.cc
  configmergedialog.cc satellitedatabasedialog.cc satelliteselectiondialog.cc
  repeaterdatabase.cc repeatercompleter.cc repeaterbooksource.cc repeatermapsource.cc
  hearhamrepeatersource.cc radioidrepeatersource.cc selectivecallbox.cc
  transponderfrequencydelegate.cc
  mainwindow.cc)
SET(qdmr_MOC_HEADERS
  configitemwrapper.hh
  application.hh settings.hh dmrcontactdialog.hh dtmfcontactdialog.hh rxgrouplistdialog.hh
  analogchanneldialog.hh digitalchanneldialog.hh channelvalidator.hh channelcombobox.hh
  channelselectiondialog.hh zonedialog.hh scanlistdialog.hh
  verifydialog.hh gpssystemdialog.hh contactselectiondialog.hh
  aprssystemdialog.hh releasenotes.hh searchpopup.hh
  roamingzonedialog.hh roamingchannellistview.hh roamingchanneldialog.hh
  roamingchannelselectiondialog.hh
  configobjectlistview.hh configobjecttableview.hh
  generalsettingsview.hh radioidlistview.hh contactlistview.hh grouplistsview.hh channellistview.hh
  zonelistview.hh scanlistsview.hh positioningsystemlistview.hh roamingzonelistview.hh
  collapsablewidget.hh extensionview.hh extensionwrapper.hh propertydelegate.hh errormessageview.hh
  deviceselectiondialog.hh radioselectiondialog.hh dmriddialog.hh configobjecttypeselectiondialog.hh
  configmergedialog.hh satellitedatabasedialog.hh satelliteselectiondialog.hh
  repeaterdatabase.hh repeatercompleter.hh repeaterbooksource.hh repeatermapsource.hh
  hearhamrepeatersource.hh radioidrepeatersource.hh selectivecallbox.hh
  transponderfrequencydelegate.hh
  mainwindow.hh)
SET(qdmr_HEADERS )
SET(qdmr_UI_FORMS dmrcontactdialog.ui dtmfcontactdialog.ui rxgrouplistdialog.ui
  analogchanneldialog.ui zonedialog.ui
  digitalchanneldialog.ui scanlistdialog.ui verifydialog.ui settingsdialog.ui
  gpssystemdialog.ui aprssystemdialog.ui
  roamingzonedialog.ui roamingchannellistview.ui roamingchanneldialog.ui
  configobjectlistview.ui configobjecttableview.ui
  generalsettingsview.ui radioidlistview.ui contactlistview.ui grouplistsview.ui channellistview.ui
  zonelistview.ui scanlistsview.ui positioningsystemlistview.ui roamingzonelistview.ui
  errormessageview.ui extensionview.ui
  deviceselectiondialog.ui radioselectiondialog.ui dmriddialog.ui configobjecttypeselectiondialog.ui
  configmergedialog.ui satellitedatabasedialog.ui satelliteselectiondialog.ui
  mainwindow.ui)

set(qdmr_TS_FILES ../i18n/de.ts ../i18n/en_US.ts ../i18n/sv.ts ../i18n/it.ts ../i18n/nl.ts
  ../i18n/pl.ts ../i18n/fr.ts)
qt5_wrap_cpp(qdmr_MOC_SOURCES ${qdmr_MOC_HEADERS})
qt5_wrap_ui(qdmr_UI_SOURCES ${qdmr_UI_FORMS})

qt5_add_translation(qdmr_QM_FILES ${qdmr_TS_FILES})
message(STATUS "Translations at: ${qdmr_QM_FILES}")

qt5_add_resources(qdmr_RCC_SOURCES ../shared/resources.qrc)

add_executable(qdmr WIN32
  ${qdmr_SOURCES} ${qdmr_MOC_SOURCES} ${qdmr_RCC_SOURCES} ${qdmr_UI_SOURCES} ${qdmr_QM_FILES})

if (UNIX AND APPLE AND INSTALL_BUNDLE)
	set_target_properties(qdmr PROPERTIES
		MACOSX_BUNDLE ON
		MACOSX_BUNDLE_BUNDLE_NAME ${CMAKE_PROJECT_NAME}
		MACOSX_BUNDLE_BUNDLE_VERSION ${CMAKE_PROJECT_VERSION}
		MACOSX_BUNDLE_GUI_IDENTIFIER "de.darc.dm3mat.qdmr"
		MACOSX_BUNDLE_ICON_FILE "Resources/qdmr.icns"
		MACOSX_BUNDLE_LONG_VERSION_STRING ${CMAKE_PROJECT_VERSION}
		MACOSX_BUNDLE_SHORT_VERSION_STRING "${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR}"
    RESOURCE "${CMAKE_SOURCE_DIR}/dist/macosx/qdmr.icns" ${qdmr_QM_FILES})
endif(UNIX AND APPLE AND INSTALL_BUNDLE)

target_link_libraries(qdmr ${LIBS} libdmrconf)
target_include_directories(qdmr PUBLIC "${CMAKE_CURRENT_BINARY_DIR}")

# Install binary only if not a bundle under MacOS X
if (UNIX AND APPLE AND INSTALL_BUNDLE)
	install(TARGETS qdmr
    BUNDLE DESTINATION ${BUNDLE_PATH}/
    RESOURCE DESTINATION "${BUNDLE_PATH}/${CMAKE_PROJECT_NAME}.app/Contents/Resources")
else()
	install(TARGETS qdmr DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})
  foreach(QM_FILE ${qdmr_QM_FILES})
     get_filename_component(QM_LANGUAGE ${QM_FILE} NAME_WE)
     install(FILES ${QM_FILE}
       DESTINATION "${LOCALE_DIRECTORY}/${QM_LANGUAGE}/LC_MESSAGES/"
       RENAME "qdmr_qt.qm")
  endforeach()
endif(UNIX AND APPLE AND INSTALL_BUNDLE)

=== test/CMakeLists.txt ===
qt5_add_resources(testlib_RCC_SOURCES resources.qrc)

qt5_wrap_cpp(libdmrconfigtest_MOC_SOURCES libdmrconfigtest.hh)
add_library(libdmrconfigtest STATIC libdmrconfigtest.cc ${libdmrconfigtest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(libdmrconfigtest ${LIBS} libdmrconf)


qt5_wrap_cpp(configtest_MOC_SOURCES configtest.hh)
add_executable(configtest configtest.cc ${configtest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(configtest ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(tableformattest_MOC_SOURCES tableformattest.hh)
add_executable(tableformattest tableformattest.cc ${tableformattest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(tableformattest ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(copytest_MOC_SOURCES copytest.hh)
add_executable(copytest copytest.cc ${copytest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(copytest ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(labeltest_MOC_SOURCES labeltest.hh)
add_executable(labeltest labeltest.cc ${labeltest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(labeltest ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(trafotest_MOC_SOURCES trafotest.hh)
add_executable(trafotest trafotest.cc ${trafotest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(trafotest ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(crc32test_MOC_SOURCES crc32test.hh)
add_executable(crc32test crc32test.cc ${crc32test_MOC_SOURCES})
target_link_libraries(crc32test ${LIBS} libdmrconf)

qt5_wrap_cpp(utilstest_MOC_SOURCES utilstest.hh)
add_executable(utilstest utilstest.cc ${utilstest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(utilstest ${LIBS} libdmrconf)

qt5_wrap_cpp(chirptest_MOC_SOURCES chirptest.hh)
add_executable(chirptest chirptest.cc ${chirptest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(chirptest ${LIBS} libdmrconf)

qt5_wrap_cpp(mergetest_MOC_SOURCES mergetest.hh)
add_executable(mergetest mergetest.cc ${mergetest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(mergetest ${LIBS} libdmrconf)

qt5_wrap_cpp(smstemplatetest_MOC_SOURCES smstemplatetest.hh)
add_executable(smstemplatetest smstemplatetest.cc ${smstemplatetest_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(smstemplatetest ${LIBS} libdmrconf libdmrconfigtest)


# Unit tests for Radioddity devices
qt5_wrap_cpp(rd5r_MOC_SOURCES rd5r_test.hh)
add_executable(rd5r_test rd5r_test.cc ${rd5r_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(rd5r_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(gd73_MOC_SOURCES gd73_test.hh)
add_executable(gd73_test gd73_test.cc ${gd73_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(gd73_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(gd77_MOC_SOURCES gd77_test.hh)
add_executable(gd77_test gd77_test.cc ${gd77_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(gd77_test ${LIBS} libdmrconf libdmrconfigtest)

# Unit tests for OpenGD77 firmware
qt5_wrap_cpp(opengd77_MOC_SOURCES opengd77_test.hh)
add_executable(opengd77_test opengd77_test.cc ${opengd77_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(opengd77_test ${LIBS} libdmrconf libdmrconfigtest)

# Unit tests for OpenGD77 firmware
qt5_wrap_cpp(openuv380_MOC_SOURCES openuv380_test.hh)
add_executable(openuv380_test openuv380_test.cc ${openuv380_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(openuv380_test ${LIBS} libdmrconf libdmrconfigtest)


# Unit tests for TyT devices
qt5_wrap_cpp(md390_MOC_SOURCES md390_test.hh)
add_executable(md390_test md390_test.cc ${md390_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(md390_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(uv390_MOC_SOURCES uv390_test.hh)
add_executable(uv390_test uv390_test.cc ${uv390_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(uv390_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(md2017_MOC_SOURCES md2017_test.hh)
add_executable(md2017_test md2017_test.cc ${md2017_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(md2017_test ${LIBS} libdmrconf libdmrconfigtest)


# Unit tests for AnyTone devices
qt5_wrap_cpp(d868uve_MOC_SOURCES d868uve_test.hh)
add_executable(d868uve_test d868uve_test.cc ${d868uve_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(d868uve_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(d878uv_MOC_SOURCES d878uv_test.hh)
add_executable(d878uv_test d878uv_test.cc ${d878uv_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(d878uv_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(d878uv2_MOC_SOURCES d878uv2_test.hh)
add_executable(d878uv2_test d878uv2_test.cc ${d878uv2_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(d878uv2_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(d578uv_MOC_SOURCES d578uv_test.hh)
add_executable(d578uv_test d578uv_test.cc ${d578uv_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(d578uv_test ${LIBS} libdmrconf libdmrconfigtest)


# Unit tests for Baofeng devices
qt5_wrap_cpp(dmr6x2uv_MOC_SOURCES dmr6x2uv_test.hh)
add_executable(dmr6x2uv_test dmr6x2uv_test.cc ${dmr6x2uv_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(dmr6x2uv_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(dm1701_MOC_SOURCES dm1701_test.hh)
add_executable(dm1701_test dm1701_test.cc ${dm1701_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(dm1701_test ${LIBS} libdmrconf libdmrconfigtest)

qt5_wrap_cpp(dr1801_MOC_SOURCES dr1801_test.hh)
add_executable(dr1801_test dr1801_test.cc ${dr1801_MOC_SOURCES} ${testlib_RCC_SOURCES})
target_link_libraries(dr1801_test ${LIBS} libdmrconf libdmrconfigtest)


add_test(NAME Config    COMMAND configtest)
add_test(NAME CRC32     COMMAND crc32test)
add_test(NAME Utils     COMMAND utilstest)
add_test(NAME CHIRP     COMMAND chirptest)

add_test(NAME RD5R      COMMAND rd5r_test)
add_test(NAME GD77      COMMAND gd77_test)

add_test(NAME OpenGD77  COMMAND opengd77_test)

add_test(NAME MD390     COMMAND md390_test)
add_test(NAME UV390     COMMAND uv390_test)
add_test(NAME MD2017    COMMAND md2017_test)

add_test(NAME D868UVE   COMMAND d868uve_test)
add_test(NAME D878UV    COMMAND d878uv_test)
add_test(NAME D878UV2   COMMAND d878uv2_test)
add_test(NAME D578UV    COMMAND d578uv_test)

add_test(NAME DMR6X2UV  COMMAND dmr6x2uv_test)
add_test(NAME DM1701    COMMAND dm1701_test)
add_test(NAME DR1801    COMMAND dr1801_test)

=== debian/changelog ===
qdmr (0.12.1-1) unstable; urgency=medium

  * Reworked CTCSS/DCS settings.
  * Reworked repeater database sources.
  * Updated OpenGD77 support to R20240908.
  * Fixed SMS bank and message offset (#467).
  * Fixed possible crash when writing to BTECH DMR-6X2UV.
  * Enforces limit on SMS messages.
  * Fixed MD380Tools button settings.
  * Merge a lot of translations into master.
  * Fixes duplication of sms templates.
  * Fix modified and main-window-close signals.
  * Fixed TX contact encoding.
  * Updated translations.

 -- Hannes Matuschek <dm3mat@darc.de>  Fri, 03 Jan 2025 12:25:00 +0100

=== debian/control ===
Source: qdmr
Priority: optional
Maintainer: Hannes Matuschek <dm3mat@darc.de>
Build-Depends: debhelper (>= 11), cmake, xsltproc, docbook-xsl, qtbase5-dev, qttools5-dev, qttools5-dev-tools, qtpositioning5-dev, libqt5serialport5-dev, libusb-1.0-0-dev, libyaml-cpp-dev
Standards-Version: 4.6.2
Section: hamradio
Vcs-Browser: https://salsa.debian.org/dm3mat/qdmr
Vcs-Git: https://salsa.debian.org/dm3mat/qdmr.git
Homepage: https://dm3mat.darc.de/qdmr

Package: libdmrconf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdmrconf0 (= ${binary:Version}), ${misc:Depends}
Description: Header files for libdmrconf
 Libdmrconf is a Qt5 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the 
 OpenGD77 firmware. This package contains the header files for libdrmconf.

Package: libdmrconf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to program DMR radios
 Libdmrconf is a Qt5 library to interface and program DMR radios. DMR is a
 digital modulation standard used in amateur and commercial radio. This library
 provides the core functionality to read, write, encode and decode binary 
 codeplugs for several radios, including AnyTone AT-D868UVE, AT-D878UV,
 AT-878UVII, AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, 
 RT3S, RT82, Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the 
 OpenGD77 firmware.

Package: qdmr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GUI application to program DMR radios
 qdmr is a Qt5 application to program DMR radios. DMR is a digital modulation
 standard used in amateur and commercial radio. To this end, qdmr is an 
 alternative codeplug programming software (CPS) that supports several radios 
 of several manufacturers. Including AnyTone AT-D868UVE, AT-D878UV, AT-878UVII, 
 AT-D578UV, TyT MD-390, MD-UV380, MD-UV390, MD-2017, Retevis RT8, RT3S, RT82, 
 Radioddity RD5R, GD-77, Baofeng DMR-6X2 and radio running the OpenGD77 
 firmware.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_MAN=ON -DINSTALL_UDEV_RULES=OFF

## qdmr 0.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.0.0)
-project(qdmr VERSION 0.12.1)
+project(qdmr VERSION 0.12.3)
 
 set(RELEASE_SUFFIX "")
 
@@ -8,6 +8,7 @@
 option(BUILD_MAN   "Build man page for dmrconf" OFF)
 option(INSTALL_UDEV_RULES "Install udev rules file." ON)
 option(INSTALL_UDEV_PATH "Install path of udev rules file." "/etc/udev/rules.d")
+option(INSTALL_APPSTREAM_DATA "Install AppStream metainfo file." ON)
 option(INSTALL_BUNDLE "Installs QDMR as an AppBundle under MacOS X" OFF)
 option(BUNDLE_PATH "Where to install the MacOS X application bundle." "~/Applications")

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
     channel.cc zone.cc scanlist.cc gpssystem.cc codeplug.cc roamingzone.cc roamingchannel.cc
     callsigndb.cc talkgroupdatabase.cc radioid.cc encryptionextension.cc commercial_extension.cc
     smsextension.cc satellitedatabase.cc orbitalelementsdatabase.cc transponderdatabase.cc
+    satelliteconfig.cc
     tyt_radio.cc tyt_interface.cc tyt_codeplug.cc tyt_callsigndb.cc tyt_extensions.cc
     md2017.cc md2017_codeplug.cc md2017_callsigndb.cc md2017_filereader.cc md2017_limits.cc
     md390.cc md390_codeplug.cc md390_filereader.cc md390_limits.cc
@@ -30,12 +31,13 @@
     rd5r.cc rd5r_codeplug.cc rd5r_filereader.cc rd5r_limits.cc
     gd77.cc gd77_codeplug.cc gd77_callsigndb.cc gd77_filereader.cc gd77_limits.cc
     opengd77_interface.cc opengd77base.cc opengd77base_codeplug.cc opengd77base_callsigndb.cc
-    opengd77_extension.cc opengd77_limits.cc
-    opengd77.cc opengd77_codeplug.cc opengd77_callsigndb.cc
-    openuv380.cc openuv380_codeplug.cc openuv380_callsigndb.cc
+    opengd77base_satelliteconfig.cc opengd77_extension.cc opengd77_limits.cc
+    opengd77.cc opengd77_codeplug.cc opengd77_callsigndb.cc opengd77_satelliteconfig.cc
+    openuv380.cc openuv380_codeplug.cc openuv380_callsigndb.cc openuv380_satelliteconfig.cc
     openrtx.cc openrtx_interface.cc openrtx_codeplug.cc
     c7000device.cc gd73.cc gd73_interface.cc gd73_codeplug.cc gd73_filereader.cc gd73_limits.cc
     anytone_interface.cc anytone_radio.cc anytone_codeplug.cc anytone_extension.cc anytone_limits.cc
+    anytone_satelliteconfig.cc
     d868uv.cc d868uv_codeplug.cc d868uv_callsigndb.cc d868uv_limits.cc
     d878uv.cc d878uv_codeplug.cc d878uv_limits.cc
     d578uv.cc d578uv_codeplug.cc d578uv_limits.cc
@@ -52,6 +54,7 @@
     channel.hh zone.hh scanlist.hh gpssystem.hh codeplug.hh roamingzone.hh roamingchannel.hh
     callsigndb.hh talkgroupdatabase.hh radioid.hh encryptionextension.hh commercial_extension.hh
     smsextension.hh satellitedatabase.hh orbitalelementsdatabase.hh transponderdatabase.hh
+    satelliteconfig.hh
     tyt_radio.hh tyt_interface.hh tyt_codeplug.hh tyt_callsigndb.hh tyt_extensions.hh
     md2017.hh md2017_codeplug.hh md2017_callsigndb.hh md2017_limits.hh
     md390.hh md390_codeplug.hh md390_limits.hh
@@ -61,12 +64,13 @@
     rd5r.hh rd5r_codeplug.hh rd5r_limits.hh
     gd77.hh gd77_codeplug.hh gd77_callsigndb.hh gd77_limits.hh
     opengd77_interface.hh opengd77base.hh opengd77base_codeplug.hh opengd77base_callsigndb.hh
-    opengd77_extension.hh opengd77_limits.hh
-    opengd77.hh opengd77_codeplug.hh opengd77_callsigndb.hh
-    openuv380.hh openuv380_codeplug.hh openuv380_callsigndb.hh
+    opengd77base_satelliteconfig.hh opengd77_extension.hh opengd77_limits.hh
+    opengd77.hh opengd77_codeplug.hh opengd77_callsigndb.hh opengd77_satelliteconfig.hh
+    openuv380.hh openuv380_codeplug.hh openuv380_callsigndb.hh openuv380_satelliteconfig.hh
     c7000device.hh gd73.hh gd73_interface.hh gd73_codeplug.hh gd73_limits.hh
     openrtx.hh openrtx_interface.hh openrtx_codeplug.hh
     anytone_interface.hh anytone_radio.hh anytone_codeplug.hh anytone_extension.hh anytone_limits.hh
+    anytone_satelliteconfig.hh
     d868uv.hh d868uv_codeplug.hh d868uv_callsigndb.hh d868uv_limits.hh
     d878uv.hh d878uv_codeplug.hh d878uv_limits.hh
     d578uv.hh d578uv_codeplug.hh d578uv_limits.hh

=== debian/changelog ===
qdmr (0.12.3-1) experimental; urgency=medium

  * Fixed radiolimits prevent setting SelectedChannel as revert channel.
  * Fixed RT3S channel linking issues.
  * Fixed auto-completion swapping of RX/TX frequency for some sources.

 -- Hannes Matuschek <dm3mat@darc.de>  Sat, 31 May 2025 11:31:01 +0200

qdmr (0.12.2-1) unstable; urgency=medium

  * Fixed linking and decoding of per-channel DMR IDs for OpenGD77, fixes #541.
  * Added support for satellite tracking function.
  * Fixed en/decoding of subtones in OpenGD77 firmwares.
  * Fixed location settings for OpenGD77 channels.
  * Fixed encoding of group list indices for OpenGD77 channels.
  * Fixed encoding of APRS settings.
  * Fixed bandwidth in CHIRP decoding.
  * Fixed enforcement of lower list limits.
  * Added channel extension, implemented TX CC encoding, fixed #561.
  * AnyTone default channel linking issue (fixed #563).
  * Fix AppStream metadata by @AsciiWolf.
  * Add Flatpak manifest by @AsciiWolf.
  * Fix OpenGD77 (UV380) codeplug encodings by @akvadrako.
  * Include Norad IDs in satellite selection by @akvadrako.
  * Made all dialogs minimum-expanding.
  * Fixed representation of selected revert channel (fixes #606).
  * Fix APRS transmit frequency handling in OpenGD77 by @akvadrako.
  * Implemented APRS PTT settings.
  * Added extension column to all table views.
  * Fixed encoding of second VHF auto-repeater frequency range.

 -- Hannes Matuschek <dm3mat@darc.de>  Fri, 30 May 2025 00:23:32 +0200
